#include "interface.h"

int SIG_COND =1;//usefull for sending kill signal while letting program clean up


void myPrint(void *ptr){
  chunk *chk = (chunk*) ptr;
  int counts[4*chk->nSamples];
  memset(counts,0,sizeof(int)*4*chk->nSamples);
  //loop over sites
  for(int s = 0 ; s<chk->l ; s++){
    //loop over individuals
    for(int i = 0 ; i<chk->nSamples ; i++){
      //skip if no depth
      if(chk->I[s][i].l!=0){
	char *nucs = chk->I[s][i].nuc;//the sequence for site s, and sample i.
	for(int ii=0;ii<chk->I[s][i].l;ii++)
	  if(nucs[ii] =='A'||nucs[ii]=='a' )
	    counts[i*4+0]++;
	  else if(nucs[ii] =='C'||nucs[ii]=='c' )
	    counts[i*4+1]++;
	  else if(nucs[ii] =='G'||nucs[ii]=='g' )
	    counts[i*4+2]++;
	  else if(nucs[ii] =='T'||nucs[ii]=='t' )
	    counts[i*4+3]++;
	//if not a nucleotide then N or n; //dont care

      }
	
      
    }
  }
  for(int i=0;i<4*chk->nSamples;i++)
    fprintf(stdout,"%d\t",counts[i]);
  fprintf(stdout,"\n");
}


void printDepth(void *ptr){
  chunk *chk = (chunk*) ptr;
  
  //loop oversites
  for(int s=0;s<chk->l;s++){
    //loop over samples
    int totDepth =0;
    for(int i=0;i<chk->nSamples;i++){
      totDepth += chk->I[s][i].l;
      fprintf(stdout,"%d\t",chk->I[s][i].l);//print the sample depth
    }
    fprintf(stdout,"%d\n",totDepth);//print the totalDepth
  }
    

}

void printDepthQS(void *ptr){
  int QS_cutoff = 37;
  chunk *chk = (chunk*) ptr;
  
  //loop oversites
  for(int s=0;s<chk->l;s++){
//loop over samples
    int totDepth =0;
    for(int i=0;i<chk->nSamples;i++){
      int sDepth =0;
      for(int ii=0;ii<chk->I[s][i].l;ii++)
	if(chk->I[s][i].qs[ii]>QS_cutoff)//only count if above cutoff
	  sDepth++;
      totDepth += sDepth;
      fprintf(stdout,"%d\t",sDepth);//print the sample depth
    }
    fprintf(stdout,"%d\n",totDepth);//print the totalDepth
  }
    

}




int main(){
  args *pars = new args;
  pars->inputfiles = "lucampHighBam.filelist";
  pars->nInd = 5;
  pars->jobtype = 2;
  pars->type =1;
  pars->callback=&printDepthQS;
  bammer_main(pars);
}
