#include <cstdlib>
#include <cstdio>
#include <ctime>
#include "parseArgs_bambi.h"
#include <csignal>
#include "bammer_main.h"
#include "interface.h"



 void info(FILE *fp){
   fprintf(fp,"single sample)\n");
   fprintf(fp,"\t1) prog TYPE .bam\n");
   fprintf(fp,"\t2) prog TYPE .bam -r REGION\n");
   fprintf(fp,"\t3) prog TYPE .bam -rf REGIONFILE chr\n");
   fprintf(fp,"multisample)\n");
   fprintf(fp,"\t4) prog TYPE -b BAMLIST \n");
   fprintf(fp,"\t5) prog TYPE -b BAMLIST -r REGION\n");
   fprintf(fp,"\t6) prog TYPE -b BAMLIST -r REGIONFILE\n");
   fprintf(fp,"TYPE=view,uppile\n");
   fprintf(fp,"REGION:\n");
   fprintf(fp,"\tchr\n");
   fprintf(fp,"\tchr:start\n");
   fprintf(fp,"\tchr:-stop\n");
   fprintf(fp,"\tchr:start-stop\n");
   fprintf(fp,"INFO:\n\tBAMLIST is filelist containing the bamfiles\n");
   fprintf(fp,"\tREGIONFILE  is filelist containing the regions\n");
   //   fprintf(fp,"General:\n\t-type INT, INT=0 slow, INT=1 fast\n");
   fprintf(fp,"GENOTYPELIKELIHOODS\n");
   fprintf(fp,"\t for uppile GL can be estimate with -GL INT\n");
   fprintf(fp,"\t -1=mpileup(no GL) 0=soap 1=samtools 2=gatk\n");
   fprintf(fp,"EXAMPLES:\n");
   fprintf(fp,"\tsamtools LK for single bam\n");
   fprintf(fp,"\t./bammer uppile -GL 1 tmp.bam\n\n");
   fprintf(fp,"samtools LK for 2 first bam in file list\n");
   fprintf(fp,"\n./bammer uppile -GL 1 tmp.bam\n");
   
   
 }


int SIG_COND =1;//if we catch signal then quit program nicely
int VERBOSE =1;
void handler(int s) {
  if(VERBOSE)
    fprintf(stderr,"Caught SIGNAL: %d will try to exit nicely (no more threads are created, we will wait for the current threads to finish)\n",s);
  VERBOSE=0;
  SIG_COND=0;
}



int main(int argc,char **argv) {
  for(int i=0;i<argc;i++)
    fprintf(stderr,"%s ",argv[i]);
  fprintf(stderr,"\n");
  //  fprintf(stderr,"Starting bammer (%s,%s)\n",__DATE__,__TIME__);
  clock_t t=clock();//how long time does the run take
  time_t t2=time(NULL);
  if(argc==1){
    info(stderr);
    return 0;
  }
  //  fprintf(stderr,"startof main\n");
  args *pars=NULL;
  //read program arguments
  if(!(pars=getArgs(++argv))){
    info(stderr);
    return 0;
  }
  //print parsed program arguments;
  //print(pars,stderr);
  //  pars->callback=myPrint;
  //setup signal handler ctrl-c and sigpipe

  //handle ctrl-c and SIGPIPE 
  struct sigaction sa;
  sigemptyset (&sa.sa_mask);
  sa.sa_flags = 0;
  sa.sa_handler = handler;
  sigaction(SIGPIPE, &sa, 0);
  sigaction(SIGINT, &sa, 0);  
  
  //now run main loop
  bammer_main(pars);
  
  fprintf(stderr, "\t[ALL done] cpu-time used =  %.2f sec\n", (float)(clock() - t) / CLOCKS_PER_SEC);
  fprintf(stderr, "\t[ALL done] walltime used =  %.2f sec\n", (float)(time(NULL) - t2));
  delete pars;
  return 0;
}
