#include <cmath>
#include "mUpPile.h"


extern int refToInt[256];

/*
  allocate the prob matrix with
  prob[1][qs] = homohit
  prob[2][qs] = hethit
  prob[3][qs] = homoNonhit

 */
double **genLikes(int len){
  double **ret = new double*[3];
  for(int i=0;i<3;i++)
    ret[i] = new double[256];
  
  for(int i=0;i<len;i++){
    double prob = pow(10,-i/10.0);
    ret[0][i] = log(2.0*prob);
    ret[1][i] = log(prob+(1-prob)/3.0);
    ret[2][i] = log(2.0*(1-prob)/3.0);
  }
  return ret;
}



int offsets[4][10]={
  {0,1,2,3,  4,5,6,7,8,9},//AA,AC,AG,AT,therest
  {4,1,5,6,  0,2,3,7,8,9},//CC,AC,CG,CT,therest
  {7,2,5,8,  0,1,3,4,6,9},//GG,AG,CG,GT,therest
  {9,3,6,8,  0,1,2,4,5,7},//TT,AT,CT,GT,therest
};



void call_gatk(chunkyT *chk,double **lk){
  static double **probs = NULL;
  if(probs==NULL)
    probs = genLikes(256);
  
  if(chk==NULL)
    return;
  
  for(int s=0;s<chk->nSites;s++){
    //    fprintf(stderr,"chr=%s \n",chk->refName);

    for(int i=0;i<chk->nSamples;i++){
      if(i==0){//allocate for all samples, for first sample
	lk[s] = new double[10*chk->nSamples];
	for(int ii=0;ii<10*chk->nSamples;ii++)
	  lk[s][ii] = -0.0;//set default values
      }
      
      tNode &nd = chk->nd[s][i];
      
      //calc like persample
      double *likes1 = lk[s]+10*i;
      for(int j=0;j<nd.l;j++){
	int allele = refToInt[nd.seq[j]];
	int qs = nd.qs[j];
	if(allele!=4){//skip N/n
	  likes1[offsets[allele][0]] += probs[0][qs]; //homozygotic hit
	  for(int o=1;o<4;o++)//heterozygotic hit
	    likes1[offsets[allele][o]] += probs[1][qs];
	  for(int o=4;o<9;o++)//non hit
	    likes1[offsets[allele][o]] += probs[2][qs];
	}
	
      }
      //    break;
    }
  }
}
